import 'package:wake_on_lan/wake_on_lan.dart';
import 'package:test/test.dart';

void main() {
    //Functions
    functionValidate();
    //Factories
    factoryFrom();
}

void functionValidate() {
    group('Function: .validate()', () {
        test('Test cases of all valid inputs', () {
            //Valid String
            String address = '192.168.1.1';
            expect(IPv4Address.validate(address), true);
            //Null String
            address = null;
            expect(IPv4Address.validate(address), false);
            //Empty String
            address = '';
            expect(IPv4Address.validate(address), false);
            //Invalid String (Alpha)
            address = 'hello';
            expect(IPv4Address.validate(address), false);
            //Invalid String (IP structure, invalid range)
            address = '192.168.1.256';
            expect(IPv4Address.validate(address), false);
        });
    });
}

void factoryFrom() {
    group('Factory: .from()', () {
        test('Create instance using valid and invalid inputs', () {
            //Valid String
            String address = '192.168.1.1';
            expect(IPv4Address.from(address), equals(isA<IPv4Address>()));
            //Null string
            address = null;
            expect(() => IPv4Address.from(address), throwsA(isA<FormatException>()));
            //Empty String
            address = '';
            expect(() => IPv4Address.from(address), throwsA(isA<FormatException>()));
            //Invalid String (Alpha)
            address = 'hello';
            expect(() => IPv4Address.from(address), throwsA(isA<FormatException>()));
            //Invalid String (IP structure, invalid range)
            address = '192.168.1.256';
            expect(() => IPv4Address.from(address), throwsA(isA<FormatException>()));
        });
    });
}