import 'package:wake_on_lan/wake_on_lan.dart';
import 'package:test/test.dart';

void main() {
    //Functions
    functionValidate();
    //Factories
    factoryFrom();
}

void functionValidate() {
    group('Function: .validate()', () {
        test('Test cases of all valid inputs', () {
            //Valid String
            String address = '00:00:00:00:00:00';
            expect(MACAddress.validate(address), true);
            //Null String
            address = null;
            expect(MACAddress.validate(address), false);
            //Empty String
            address = '';
            expect(MACAddress.validate(address), false);
            //Invalid String (Alpha)
            address = 'hello';
            expect(MACAddress.validate(address), false);
            //Invalid String (MAC structure, invalid octet)
            address = '00:00:00:00:FG:00';
            expect(MACAddress.validate(address), false);
            //Invalid String (MAC structure, invalid octet)
            address = '00:00:00:00:A:00';
            expect(MACAddress.validate(address), false);
        });
    });
}

void factoryFrom() {
    group('Factory: .from()', () {
        test('Create instance using valid and invalid inputs', () {
            //Valid String
            String address = '00:00:00:00:00:00';
            expect(MACAddress.from(address), equals(isA<MACAddress>()));
            //Null string
            address = null;
            expect(() => MACAddress.from(address), throwsA(isA<FormatException>()));
            //Empty String
            address = '';
            expect(() => MACAddress.from(address), throwsA(isA<FormatException>()));
            //Invalid String (Alpha)
            address = 'hello';
            expect(() => MACAddress.from(address), throwsA(isA<FormatException>()));
            //Invalid String (MAC structure, invalid octet)
            address = '00:00:00:00:FG:00';
            expect(() => MACAddress.from(address), throwsA(isA<FormatException>()));
            //Invalid String (MAC structure, invalid octet)
            address = '00:00:00:00:A:00';
            expect(() => MACAddress.from(address), throwsA(isA<FormatException>()));
        });
    });
}